//+-------------------------------------------------------------------------------+ 
//|                    heiken ashi ma adaptive T3.mq4                             | 
//+-------------------------------------------------------------------------------+
//+-------------------------------------------------------------------------------+
//|                  Copyright  2011,http://www.forex-tsd.com                    |
//|       You are NOT ALLOWED to distribute this Indicator in any public forum    |
//|           Property of  http://www.forex-tsd.com ELITE section ONLY            |
//|                       WARNING, Use this Indicator at your risk                |
//|                                                                               |
//+-------------------------------------------------------------------------------+
#property copyright "http://www.forex-tsd.com"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  OrangeRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  OrangeRed
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2
#property indicator_minimum 0
#property indicator_maximum 2

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    MaPeriod         = 10;
extern int    MaMetod          = 2;
extern int    Step             = 10;
extern bool   BetterFormula    = true;
extern bool   T3Average        = true;
extern int    T3Period         = 10;
extern double T3Hot            = 0.618;
extern bool   T3Original       = false;
extern bool   T3Adaptive       = true;

extern string _                = "Alerts settings";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double histUp1[];
double histDn1[];
double histUp2[];
double histDn2[];
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double trend[][2];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0, histUp1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, histDn1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, histUp2); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, histDn2); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4, ExtMapBuffer1);
   SetIndexBuffer(5, ExtMapBuffer2);
   SetIndexBuffer(6, ExtMapBuffer3);
   SetIndexBuffer(7, ExtMapBuffer4);

   //
   //
   //
   //
   //
   
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
      
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+  "  Heiken Ashi Adaptive T3 Histo");
 return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   
   int    counted_bars=IndicatorCounted();
   int    pointModifier;
   int    pos,r,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { histUp1[0] = limit+1; return(0); }
         if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);
         
         if (Digits==3 || Digits==5)
               pointModifier = 10;
         else  pointModifier = 1;   
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {          
   
      for(pos = limit,r = Bars - pos - 1; pos >= 0; pos--,r++)
      {
         if (T3Average)
            {
               double maOpen  = iT3a(Open[pos], T3Period,T3Hot,T3Original,T3Adaptive,pos,0);  
               double maClose = iT3a(Close[pos],T3Period,T3Hot,T3Original,T3Adaptive,pos,1);  
               double maLow   = iT3a(Low[pos],  T3Period,T3Hot,T3Original,T3Adaptive,pos,2);  
               double maHigh  = iT3a(High[pos], T3Period,T3Hot,T3Original,T3Adaptive,pos,3);  
            }
         else
            {
               maOpen  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_OPEN ,pos);
               maClose = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_CLOSE,pos);
               maLow   = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_LOW  ,pos);
               maHigh  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_HIGH ,pos);
            }
   
         //
         //
         //
         //
         //
        
         if (BetterFormula) {
                if (maHigh != maLow)
                     double haClose = (maOpen+maClose)/2+(((maClose-maOpen)/(maHigh-maLow))*MathAbs((maClose-maOpen)/2));
                else        haClose = (maOpen+maClose)/2; }
                else        haClose = (maOpen+maHigh+maLow+maClose)/4;
                     double haOpen   = (ExtMapBuffer3[pos+1]+ExtMapBuffer4[pos+1])/2;
                     double haHigh   = MathMax(maHigh, MathMax(haOpen,haClose));
                     double haLow    = MathMin(maLow,  MathMin(haOpen,haClose));

         if (haOpen<haClose) { ExtMapBuffer1[pos]=haLow;  ExtMapBuffer2[pos]=haHigh; } 
         else                { ExtMapBuffer1[pos]=haHigh; ExtMapBuffer2[pos]=haLow;  } 
                               ExtMapBuffer3[pos]=haOpen;
                               ExtMapBuffer4[pos]=haClose;
      
         //
         //
         //
         //
         //

         if (Step>0)
         {
            if( MathAbs(ExtMapBuffer1[pos]-ExtMapBuffer1[pos+1]) < Step*pointModifier*Point ) ExtMapBuffer1[pos]=ExtMapBuffer1[pos+1];
            if( MathAbs(ExtMapBuffer2[pos]-ExtMapBuffer2[pos+1]) < Step*pointModifier*Point ) ExtMapBuffer2[pos]=ExtMapBuffer2[pos+1];
            if( MathAbs(ExtMapBuffer3[pos]-ExtMapBuffer3[pos+1]) < Step*pointModifier*Point ) ExtMapBuffer3[pos]=ExtMapBuffer3[pos+1];
            if( MathAbs(ExtMapBuffer4[pos]-ExtMapBuffer4[pos+1]) < Step*pointModifier*Point ) ExtMapBuffer4[pos]=ExtMapBuffer4[pos+1];
         } 
              
         trend[r][0] = trend[r-1][0];
         trend[r][1] = trend[r-1][1];
         if (ExtMapBuffer1[pos]>ExtMapBuffer2[pos]) trend[r][0] = -1;
         if (ExtMapBuffer1[pos]<ExtMapBuffer2[pos]) trend[r][0] =  1;
         if (ExtMapBuffer3[pos]>ExtMapBuffer4[pos]) trend[r][1] = -1;
         if (ExtMapBuffer3[pos]<ExtMapBuffer4[pos]) trend[r][1] =  1;
      
         //
         //
         //
         //
         //
      
         histUp1[pos] = EMPTY_VALUE;
         histDn1[pos] = EMPTY_VALUE;
         histUp2[pos] = EMPTY_VALUE;
         histDn2[pos] = EMPTY_VALUE;
         if (trend[r][1] ==  1) histUp2[pos]=1;
         if (trend[r][1] == -1) histDn2[pos]=1;
         if (trend[r][0] ==  1) histUp1[pos]=2;
         if (trend[r][0] == -1) histDn1[pos]=2;
         
         }
         
         //
         //
         //
         //
         //
         
    manageAlerts();
    return(0);
    }
    
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   
   for(pos = limit,r = Bars - pos - 1; pos >= 0; pos--,r++)
   {
   
     int y = iBarShift(NULL,timeFrame,Time[pos]);
  
       ExtMapBuffer1[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaMetod,Step,BetterFormula,T3Average,T3Period,T3Hot,T3Original,T3Adaptive,0,y);
       ExtMapBuffer2[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaMetod,Step,BetterFormula,T3Average,T3Period,T3Hot,T3Original,T3Adaptive,1,y);
       ExtMapBuffer3[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaMetod,Step,BetterFormula,T3Average,T3Period,T3Hot,T3Original,T3Adaptive,2,y);
       ExtMapBuffer4[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaMetod,Step,BetterFormula,T3Average,T3Period,T3Hot,T3Original,T3Adaptive,3,y);
       
       trend[r][0] = trend[r-1][0];
       trend[r][1] = trend[r-1][1];
       if (ExtMapBuffer1[pos]>ExtMapBuffer2[pos]) trend[r][0] = -1;
       if (ExtMapBuffer1[pos]<ExtMapBuffer2[pos]) trend[r][0] =  1;
       if (ExtMapBuffer3[pos]>ExtMapBuffer4[pos]) trend[r][1] = -1;
       if (ExtMapBuffer3[pos]<ExtMapBuffer4[pos]) trend[r][1] =  1;
      
       //
       //
       //
       //
       //
      
       histUp1[pos] = EMPTY_VALUE;
       histDn1[pos] = EMPTY_VALUE;
       histUp2[pos] = EMPTY_VALUE;
       histDn2[pos] = EMPTY_VALUE;
       if (trend[r][1] ==  1) histUp2[pos]=1;
       if (trend[r][1] == -1) histDn2[pos]=1;
       if (trend[r][0] ==  1) histUp1[pos]=2;
       if (trend[r][0] == -1) histDn1[pos]=2;
         
       }
         
       //
       //
       //
       //
       //
         
    manageAlerts();
  return(0);
}
   
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar][0] != trend[whichBar-1][0])
      {
         if (trend[whichBar][0] == 1)  doAlert(whichBar,"up");
         if (trend[whichBar][0] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," T3 Heiken Ashi changed direction to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," T3 Heiken Ashi "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][28];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5
#define _atr    6

//
//
//
//
//

double iT3a(double price, double period, double hot, bool original, bool adaptive, int i, int forInstance=0)
{
   int r      = Bars-i-1;
   int buffer = forInstance*7;

   //
   //
   //
   //
   //
   
      if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
      if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);
      if (adaptive)
      {
         workT3[r][_atr+buffer] = iATR(NULL,0,period,i);
            double max = workT3[r][_atr+buffer];
            double min = workT3[r][_atr+buffer];
            for (int k=1; k<period && (r-k>=0); k++)
               {
                  max = MathMax(max,workT3[r-k][_atr+buffer]);
                  min = MathMin(min,workT3[r-k][_atr+buffer]);
               }
            if (min!=max)
                  double atn = 1.0-(workT3[r][_atr+buffer]-min)/(max-min);
            else         atn = 0.5;
            period = period*(atn+1.0)/2.0;
      }
   
   //
   //
   //
   //
   //
   
      if (workT3Coeffs[forInstance][_period] != period)
      {
        workT3Coeffs[forInstance][_period] = period;
           double a = hot;
               workT3Coeffs[forInstance][_c1] = -a*a*a;
               workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
               workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
               workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
               if (original)
                    workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
               else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
      }
   
   //
   //
   //
   //
   //
   
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}

//
//
//
//
//


